using System.Reflection;
using FitConnect.Models;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json.Schema;

namespace FitConnect;

public class Subscriber : FunctionalBaseClass, ISubscriber {
    public Subscriber(ILogger logger, FitConnectEndpoints endpoints) : base(logger, endpoints) {
    }

    public async Task<string> DecryptDataAsync(string data, string privateKey) {
        throw new NotImplementedException();
    }

    public async Task<string> DecryptAttachmentAsync(string attachment, string privateKey) {
        throw new NotImplementedException();
    }

    private async Task<string> GetContentFromEmbeddedResource(string filename) {
        var assembly = typeof(Subscriber).GetTypeInfo().Assembly;
        var resourceName = $"{assembly.GetName().Name}.{filename}";
        using (var stream = assembly.GetManifestResourceStream(resourceName)) {
            if (stream == null) {
                throw new Exception($"Could not find embedded resource {resourceName}");
            }

            using (var reader = new StreamReader(stream)) {
                return await reader.ReadToEndAsync();
            }
        }
    }

    /// <summary>
    /// Checks the validity of the given metadata against the schema.
    /// </summary>
    /// <param name="jsonMetaData">JSON meta data</param>
    /// <returns></returns>
    public async Task<bool> CheckMetadataAsync(string jsonMetaData) {
        var jsonScheme =
            JSchema.Parse(await GetContentFromEmbeddedResource("metadata.schema.json"));

        var meta = JObject.Parse(jsonMetaData);
        return meta.IsValid(jsonScheme);
    }

    public async Task<bool> CheckHashAsync(string metadata) {
        throw new NotImplementedException();
    }

    public async Task<SecurityEventToken> CreateSecurityEventTokenAsync(string data,
        string attachment, string privateKey) {
        throw new NotImplementedException();
    }
}
